
#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>

@class ImageBrowserController;

@interface AppWindowController : NSWindowController < NSApplicationDelegate >
{
	IBOutlet ImageBrowserController * mImageBrowserController;
	IBOutlet id mImageBrowser;
	IBOutlet id mImageView;
	IBOutlet id mDirectoryBrowser;
	
	IBOutlet NSSplitView * mHorizontalSplit;
	IBOutlet NSSplitView * mVerticalSplit;
	
	NSMutableArray * mCutFiles;
	NSMutableArray * mCopiedFiles;

	NSWindow * mWindow;
}

@property (assign) IBOutlet NSWindow * window;

// application delegate
-(void)applicationWillFinishLaunching:(NSNotification *)notification;
-(void)applicationDidFinishLaunching:(NSNotification *)aNotification;
-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)sender;
-(void)applicationWillTerminate:(NSNotification *)aNotification;

// init / dealloc
-(void)awakeFromNib;
-(void)dealloc;

// menu actions
-(IBAction)showPreferencesWindow:(id)sender;
-(IBAction)deleteFiles:(id)sender;
-(IBAction)copyFiles:(id)sender;
-(IBAction)cutFiles:(id)sender;
-(IBAction)pasteFiles:(id)sender;

@end
