#import "AppWindowController.h"
#import "PreferencesWindowController.h"
#import "ImageView.h"
#import "ImageBrowserController.h"
#import "ImageBrowserItem.h"


@implementation AppWindowController

@synthesize window = mWindow;

-(void)awakeFromNib
{
	// initialize the image view with nil (if we don't do that, we will see
	// artefacts in the IKImageView
	[mImageView setImageWithURL:nil];

	// initialize the arrays for copy / cut / paste
	mCutFiles = [[NSMutableArray alloc] init];
	mCopiedFiles = [[NSMutableArray alloc] init];
}

-(void)dealloc
{
	[mCutFiles release];
	[mCopiedFiles release];
	[super dealloc];
}

-(void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	// configure the shared user defaults to save changes immediately
	NSUserDefaultsController * defaults = [NSUserDefaultsController sharedUserDefaultsController];
	[defaults setAppliesImmediately:YES];
}

-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)sender
{
	return YES;
}

-(void)applicationWillFinishLaunching:(NSNotification *)notification
{
	// initialize user defaults
	NSData * colorData = [NSKeyedArchiver archivedDataWithRootObject:[NSColor blackColor]];
	NSDictionary * defaults = [NSDictionary dictionaryWithObjectsAndKeys:colorData, @"backgroundColor",
							   [NSNumber numberWithFloat:0.38f], @"thumbnailSize", nil];
	[[NSUserDefaults standardUserDefaults] registerDefaults:defaults];
}

-(void)applicationWillTerminate:(NSNotification *)aNotification
{
	if ([mImageView isInFullScreenMode] == YES)
		[mImageView toggleFullscreen];
}

-(IBAction)showPreferencesWindow:(id)sender
{
	[[PreferencesWindowController sharedInstance] runModal];
}

-(IBAction)deleteFiles:(id)sender
{
/*	NSFileManager * fileManager = [NSFileManager defaultManager];
	NSArray * files = [mImageBrowserController selectedImages];
	for (ImageBrowserItem * item in files)
		[fileManager removeItemAtPath:[item path] error:NULL];
*/}

-(IBAction)copyFiles:(id)sender
{
//	[mCutFiles removeAllObjects];
//	[mCopiedFiles addObjectsFromArray:[mImageBrowserController selectedImages]];
}

-(IBAction)cutFiles:(id)sender
{
//	[mCopiedFiles removeAllObjects];
//	[mCutFiles addObjectsFromArray:[mImageBrowserController selectedImages]];
}

-(IBAction)pasteFiles:(id)sender
{
/*	NSFileManager * fileManager = [NSFileManager defaultManager];
	if ([mCutFiles count] > 0)
	{
		for (ImageBrowserItem * item in mCutFiles)
			[fileManager moveItemAtPath:[item path] toPath:[mImageBrowserController path] error:NULL];
		[mCutFiles removeAllObjects];
	}
	else if ([mCopiedFiles count] > 0)
	{
		for (ImageBrowserItem * item in mCopiedFiles)
			[fileManager copyItemAtPath:[item path] toPath:[mImageBrowserController path] error:NULL];
		[mCopiedFiles removeAllObjects];
	}
*/}

@end
