#import <Cocoa/Cocoa.h>


@interface DirectoryBrowserItem : NSObject
{
	NSString * mPath;				///< the complete path for this item
	NSMutableArray * mChildren;		///< the list of children
	NSString * mName;				///< the name (last path component)
	NSImage * mImage;				///< the icon of the folder
	DirectoryBrowserItem * mParent;	///< pointer to the parent
}

@property (readonly) NSString * path;
@property (readonly) NSString * name;
@property (readonly) DirectoryBrowserItem * parent;
@property (readwrite, assign) NSImage * image;

-(id)initWithPath:(NSString *)path andParent:(id)parent;
-(void)dealloc;

-(DirectoryBrowserItem *)parent;
-(NSString *)path;
-(NSString *)name;
-(NSMutableArray *)children;

@end
