#import "DirectoryBrowserItem.h"


@implementation DirectoryBrowserItem


@synthesize parent	= mParent;
@synthesize name	= mName;
@synthesize path	= mPath;
@synthesize image	= mImage;


-(id)initWithPath:(NSString *)path andParent:(id)parent
{
	self = [super init];
	if (self != nil)
	{
		mPath		= [path copy];
		mChildren	= nil;
		mImage		= nil;
		mParent		= parent;
		mName		= [[mPath lastPathComponent] retain];
	}
	return self;
}

-(void)dealloc
{
	[mPath release];
	[mName release];
	[mChildren release];
	[mImage release];
	[super dealloc];
}

-(NSMutableArray *)children
{
	// first time children is accessed, initliaze its content
	if (mChildren == nil)
	{
		mChildren = [[NSMutableArray alloc] init];
		NSFileManager * fileManager = [NSFileManager defaultManager];
		NSArray * content = [fileManager contentsOfDirectoryAtPath:mPath error:nil];
		BOOL isDirectory;
		for (NSString * file in content)
		{
			// ignore hidden directories
			if ([file characterAtIndex:0] == '.')
				continue;
			
			NSString * fullPath = [mPath stringByAppendingPathComponent:file];
			if ([fileManager fileExistsAtPath:fullPath isDirectory:&isDirectory] == YES && isDirectory == YES)
			{
				DirectoryBrowserItem * item = [[DirectoryBrowserItem alloc] initWithPath:fullPath andParent:self];
				[mChildren addObject:item];
				[item release];
			}
		}
	}
	return mChildren;
}

@end
