#import "ImageBrowserItem.h"
#import <Quartz/Quartz.h>


@implementation ImageBrowserItem

@synthesize isDirectory = mIsDirectory;

-(void)dealloc
{
	[mPath release];
	[mTitle release];
	[super dealloc];
}

-(void)setPath:(NSString *)path
{
	if (mPath != path)
	{
		[mPath release];
		mPath = [path retain];
	}
}

-(NSString *)path
{
	return mPath;
}

-(void)setTitle:(NSString *)title
{
	if (mTitle != title)
	{
		[mTitle release];
		mTitle = [title copy];
	}
}

-(NSString *)imageRepresentationType
{
	return IKImageBrowserPathRepresentationType;
}

-(id)imageRepresentation
{
	return mPath;
}

-(NSString *)imageUID
{
	return mPath;
}

-(NSString *)imageTitle
{
	if (mTitle == nil)
		return [mPath lastPathComponent];
	return mTitle;
}

@end
