#import "ImageView.h"
#import "ImageBrowserController.h"


@implementation ImageView

@synthesize mainWindow = mWindow;
@synthesize imageBrowser = mImageBrowser;
@synthesize verticalSplit = mVerticalSplit;


-(void)awakeFromNib
{
	mCurrentURL = nil;
//	[self setOverlay:[CALayer layer] forType:IKOverlayTypeImage];
}

-(void)setImageWithURL:(NSURL *)url
{
/*	if (url == nil)
	{
		[mCurrentURL release];
		mCurrentURL = nil;
	}
	else
	{
		if (mCurrentURL != url)
		{
			[mCurrentURL release];
			mCurrentURL = [url copy];
		}
	}
*/
	[super setImageWithURL:url];
//	[[self overlayForType:IKOverlayTypeImage] setContents:[self image]];
}

-(void)toggleFullscreen
{
	static id oldFirstResponder = nil;

	if ([self isInFullScreenMode] == YES)
	{
		// restore the previous first responder
		[mWindow makeFirstResponder:oldFirstResponder];
		
		// exit fullscreen
		[NSCursor unhide];
		[self exitFullScreenModeWithOptions:nil];
	}
	else
	{
		// back the first responder
		oldFirstResponder = [mWindow firstResponder];
		
		// create a dictionary for the fullscreen options
		// NSApplicationPresentationDefault is used so that we can still use Spaces, swtich process, etc.
		// NSFullScreenModeWindowLevel is used to display on top of everything
		NSMutableDictionary * options = [NSMutableDictionary dictionary];
		[options setValue:[NSNumber numberWithInt:NSMainMenuWindowLevel + 1] forKey:NSFullScreenModeWindowLevel];
		[options setValue:[NSNumber numberWithInt:NSApplicationPresentationDefault] forKey:NSFullScreenModeApplicationPresentationOptions];

		// enter fullscreen mode and make the view the first responder
		[self enterFullScreenMode:[NSScreen mainScreen] withOptions:options];
		[mWindow makeFirstResponder:self];
		[NSCursor hide];
	}
	
	// reset zoom
//	NSURL * url = [mCurrentURL copy];
//	[self setImageWithURL:nil];
//	[self setImageWithURL:url];
//	[url release];
//	[NSThread detachNewThreadSelector:@selector(addImagesInPath:) toTarget:self withObject:mPath];
//	[NSThread detachNewThreadSelector:@selector(setImageWithURL:) toTarget:self withObject:mCurrentURL];
//	[self setImageWithURL:mCurrentURL];
	[self zoomImageToFit:self];
	[self setAutoresizes:YES];
}

-(void)keyDown:(NSEvent *)theEvent
{
	NSString * characters = [theEvent characters];
	NSUInteger modifier = [theEvent modifierFlags];
	unichar event = [characters characterAtIndex:0];
	switch (event)
	{
		case 27:
			// escape : if not in fullscreen, do nothing
			if ([self isInFullScreenMode] == NO)
				break;

		case 13:
			// enter and escape (when not in fullscreen) toggles fullscreen
			[self toggleFullscreen];
			break;

		case NSUpArrowFunctionKey:
		case NSLeftArrowFunctionKey:
		{
			// decrement the current image index
			int index = [[mImageBrowser selectionIndexes] firstIndex];
			if (modifier & NSShiftKeyMask)			index -= 5;
			else if (modifier & NSControlKeyMask)	index -= 10;
			else if (modifier & NSCommandKeyMask)	index -= 20;
			else									--index;
			
			// check the bound
			if (index < 0)
				index = 0;

			// set the new selected index
			[mImageBrowser setSelectionIndexes:[NSIndexSet indexSetWithIndex:index] byExtendingSelection:NO];
			break;
		}

		case NSDownArrowFunctionKey:
		case NSRightArrowFunctionKey:
		{
			// increment the current image index
			NSUInteger index = [[mImageBrowser selectionIndexes] firstIndex];
			if (modifier & NSShiftKeyMask)			index += 5;
			else if (modifier & NSControlKeyMask)	index += 10;
			else if (modifier & NSCommandKeyMask)	index += 20;
			else									++index;

			// check the bound
			if (index > [[mImageBrowser delegate] numberOfItemsInImageBrowser:mImageBrowser] - 1)
				index = [[mImageBrowser delegate] numberOfItemsInImageBrowser:mImageBrowser] - 1;
			
			// set the new selected index
			[mImageBrowser setSelectionIndexes:[NSIndexSet indexSetWithIndex:index] byExtendingSelection:NO];
			break;
		}
		
		default:
			[super keyDown:theEvent];
	}
	
}

@end
